#! /usr/bin/perl
print "Content-type: text/html\n\n";

if ($ENV{"REQUEST_METHOD"} eq "POST") {
  read(STDIN, $datastring, $ENV{"CONTENT_LENGTH"});		
}
elsif (exists $ENV{"REQUEST_METHOD"}) {		# data from GET transaction (or HEAD or other)
  $datastring = $ENV{"QUERY_STRING"};
}
else {
  print "Offline execution detected\n";
  print "Please enter some data.\n";
  $datastring = <>;
  chomp $datastring;
  print "== data accepted == HTML output follows ==\n\n";
}

###decode######################################################
$datastring =~s/%0D%0A/\n/g;                    			#step to deal with line
																											#breaks in text areas
@nameValuePairs = split(/&/, $datastring);						#step 1
foreach $pair (@nameValuePairs) {
  ($name, $value) = split(/=/, $pair);								#step 2
  
  $name =~tr/+/ /;                                 		#step 3
  $name =~s/%([\da-fA-F]{2})/pack("C",hex($1))/eg; 		#step 3
  $value =~tr/+/ /;                                		#step 3
  $value =~s/%([\da-fA-F]{2})/pack("C",hex($1))/eg;		#step 3
  
  if(exists $formHash{$name}) {												#improved step 4,
    $formHash{$name} = $formHash{$name}.";".$value;		#now handles multiple
  }																										#select menus
  else {
    $formHash{$name} = $value;
  }   	
}
###done decoding###############################################


$dataDir = ""; # the directory containing the file comments.txt
$dataURL = "http://www.cknuckles.com/webapps/downloads/source/chap06/"; # the corresponding URL

$comments = $formHash{"comments"};
chomp $comments;

# open for appending
open(DATA, ">>$dataDir"."comments.txt") || &errorPage;

print DATA $comments;
print DATA "\n", "-" x 70, "\n"; # a line of 70 dashes to separate comments
close(DATA);

$url = $dataURL."comments.txt";
print<<PAGE;
<html><head><title>Thank you</title></head>
 <body>
 Thank you for your comments. You may
 <a href="$url">view all comments</a>.
 </body>
</html>
PAGE

##############################################################
sub errorPage {
print<<ERRORPAGE;
<html>
 <head>
  <title>Error-please try again</title>
 </head>
 <body>
 There was an error saving your comments. Please use the Back button
 on your browser and try again. Or report the problem to the webmaster.
 </body>
</html>
ERRORPAGE

exit;  # exits program if this error encountered
}
