#! /usr/bin/perl
print "Content-type: text/html\n\n";

if ($ENV{"REQUEST_METHOD"} eq "POST") {
  read(STDIN, $datastring, $ENV{"CONTENT_LENGTH"});		
}
elsif (exists $ENV{"REQUEST_METHOD"}) {			# data from GET transaction (or HEAD or other)
  $datastring = $ENV{"QUERY_STRING"};
}
else {
  print "Offline execution detected\n";
  print "Please enter some data.\n";
  $datastring = <>;
  chomp $datastring;
  print "== data accepted == HTML output follows ==\n\n";
}

###decode######################################################
@nameValuePairs = split(/&/, $datastring);				 #step 1.
foreach $pair (@nameValuePairs) {
  ($name, $value) = split(/=/, $pair);			 			 #step 2.
  $name =~tr/+/ /;                                 #step 3.
  $name =~s/%([\da-fA-F]{2})/pack("C",hex($1))/eg; #step 3.
  $value =~tr/+/ /;                                #step 3.
  $value =~s/%([\da-fA-F]{2})/pack("C",hex($1))/eg;#step 3.
  $value =~s/[<>]//g;					#precaution
  $formHash{$name}=$value;                    		 #step 4.
}
###done decoding###############################################

$cheesetotal = sprintf "%.2f", $formHash{"cheeseburger"}*1.50;
$veggietotal = sprintf "%.2f", $formHash{"veggieburger"}*1.50;
$friestotal = sprintf "%.2f", $formHash{"fries"}*1.00;
$drinktotal = sprintf "%.2f", $formHash{"drink"}*0.80;
$totalCost = sprintf "%.2f", $cheesetotal+$veggietotal+$friestotal+$drinktotal;

print <<WHOLEPAGE;
<html><head><title>Thank you for your order</title></head>
<body>
<table border="1">
	<tr>
		<th>Food</th><th>Quantity</th><th>Subtotal</th>
	</tr>
  <tr>
  	<td>Cheeseburger (\$1.50)</td><td>$formHash{"cheeseburger"}</td><td>\$$cheesetotal</td>
  </tr>
  <tr>
   	<td>Veggieburger (\$1.50)</td><td>$formHash{"veggieburger"}</td><td>\$$veggietotal</td>
  </tr>
  <tr>
  	<td>Fries (\$1.00)</td><td>$formHash{"fries"}</td><td>\$$friestotal</td>
  </tr>
  <tr>
   	<td>Drink (\$0.80)</td><td>$formHash{"drink"}</td><td>\$$drinktotal</td>
  </tr>
  <tr>
   	<td colspan="2"><b>TOTAL</b></td><td>\$$totalCost</td>
  </tr>
</table>

</body></html>
WHOLEPAGE
