#! /usr/bin/perl
print "Content-type: text/html\n\n";

if ($ENV{"REQUEST_METHOD"} eq "POST") {		
  read(STDIN, $datastring, $ENV{"CONTENT_LENGTH"});		
}
elsif (exists $ENV{"REQUEST_METHOD"}) {     # data from GET transaction (or HEAD or other)
  $datastring = $ENV{"QUERY_STRING"};
}
else {
  print "Offline execution detected\n";
  print "Please enter some data.\n";
  $datastring = <>;
  chomp $datastring;
  print "== data accepted == HTML output follows ==\n\n";
}

###decode######################################################
@nameValuePairs = split(/&/, $datastring);					#step 1
foreach $pair (@nameValuePairs) {
  ($name, $value) = split(/=/, $pair);							#step 2
  $name =~tr/+/ /;                                 	#step 3
  $name =~s/%([\da-fA-F]{2})/pack("C",hex($1))/eg; 	#step 3
  $value =~tr/+/ /;                                	#step 3
  $value =~s/%([\da-fA-F]{2})/pack("C",hex($1))/eg;	#step 3
  $formHash{$name}=$value;                    			#step 4
}
###done decoding###############################################

###############################################################
# %formHash is at your disposal for the rest of               #
# the program regardless of the input method 				   				#
###############################################################


print <<WHOLEPAGE;
<html><head><title>Welcome $formHash{"thename"}</title></head>
<body>
<h2>Welcome to our website, $formHash{"thename"}.</h2>
</body>
</html>
WHOLEPAGE

